#include "pawprint.h"
#include "util.h"

#include <assert.h>
#include <iostream>
#include <opencv/cv.h>
#include <vector>

using namespace cv;
using namespace std;

PawPrint::PawPrint(Point2f center, Point2f digit, int id)
{

	this -> center = center;
	this -> digit = digit;
	this -> id = id;

}

Point2f PawPrint::getCenter()
{
	return center;
}

Point2f PawPrint::getDigit()
{
	return digit;
}

Point2f PawPrint::getOrientation()
{
	return Util::normalize(digit - center);
}

int PawPrint::getID()
{
	return id;
}

void PawPrint::draw(Mat &frame)
{

	const Point2f UNDERLINE_PT1 = center + Point2f(20, 30);
	const Point2f UNDERLINE_PT2 = Point2f(UNDERLINE_PT1.x + 50, UNDERLINE_PT1.y);

	const Point2f TEXT_POS = UNDERLINE_PT1 + Point2f(2, -7);
	const Scalar COLOR(255, 175, 50);
	const float TEXT_SCALE = 0.4;
	char info[16];

	line(frame, center, digit, COLOR, 2);
	line(frame, center, UNDERLINE_PT1, COLOR);
	line(frame, UNDERLINE_PT1, UNDERLINE_PT2, COLOR);
	circle(frame, center, Util::length(digit - center) * 1.5, COLOR, 2);
	
	sprintf(info, "Pawprint #%d", id);
	putText(frame, info, TEXT_POS, FONT_HERSHEY_SIMPLEX, TEXT_SCALE, COLOR);

}
