#pragma once

#include "pawprint.h"

#include <opencv/cv.h>
#include <vector>

using namespace cv;
using namespace std;

class PawPrintTracker
{

	public:
	
		static void init();
		
		static void openTrackingWindow();
		static void updateTrackingWindow();
		
		static void preprocessFrame(Mat, Mat&);
		static void findPawPrints(Mat&, vector<PawPrint*>&);
		static void drawPawPrints(Mat&, vector<PawPrint*>&);
		
	private:
	
		static const char *TRACKING_WINDOW_NAME;
		
		static Mat trackingWindowFrame;
	
		static int thresholdValue;
		static int erodeValue;
		static int dilateValue;
		
		static SimpleBlobDetector *blobDetector;
	
		static void initBlobDetectors();
		
		static void findPawCenters(Mat&, vector<KeyPoint>&, vector<KeyPoint>&);
		static void findPawDigits(Mat&, vector<KeyPoint>&, vector<KeyPoint>&, vector<PawPrint*>&);
		static bool getSmallestDigit(vector<KeyPoint>&, Point2f, int, Point2f&);
		static int getPrintID(Point2f, Point2f, Mat&);

};
