#pragma once

#include <opencv/cv.h>
#include <opencv/highgui.h>

using namespace cv;

class Util
{

	public:
	
		static int min(int, int);
		static int max(int, int);
		
		static Point2f average(Point2f, Point2f);
		static Point2f average(Point2f, Point2f, Point2f);
		static Point2f average(vector<Point2f>);
		
		static float length(Point2f);
		static float dist(Point2f, Point2f);
		static float angle(Point2f);
		static Point2f normalize(Point2f);
		static Point2f vecAtAngle(float);
		
		static float radToDeg(float);
		static float degToRad(float);
		static float wrapvalue(float);
		
		static Vec3b matToVec3b(Mat);
		static Mat vec3bToMat(Vec3b);
		static Point2f keyPointToPoint(KeyPoint);
		
		static int getFurthestFromAverage(vector<Point2f>);
		
		static float areaToRadius(float);
		
		static void sortKeyPointsDownBySize(vector<KeyPoint>&);
		
};
